﻿/* Event Cats Javascript functions LucMorizur June - ... 2009 */

var ec_err = '';
var ec_avoid_infinite_loop = true;
var ec_checked_line = 0;
var ec_selected_user = 'ec_sel_user_old';
var ec_selected_old_user = '-1';
var ec_selected_AP = '-1';
var ec_selected_cat = '-1';
var ec_selected_action = '';
var ec_selected_img = '';
var ec_auto_code_digits_nb = '8';
var ec_new_code_text = '';
var ec_new_user_text = '';
var ec_new_psd_text = '';
var ec_old_new_psd_text = '';
var ec_checked_URL = new Array();
var ec_JS_message = new Array();
var ec_test_reg = '';

function ec_mark_line(ec_id) {
  ec_checked_line = ec_id;
  if (ec_checked_line == 0) {
    document.getElementById('selection--1').checked = 'checked';
    document.getElementById('selection--1').checked = '';
    document.getElementById('ec_show_URL').value = '';
  }
  else {
    document.getElementById("selection-" + ec_checked_line).checked = 'checked';
    document.getElementById('ec_show_URL').value =
     ec_checked_URL[ec_checked_line];
  }
  if (ec_checked_line >= 0) {
    document.getElementById('ec_sel_user_none').checked = 'checked';
    document.getElementById('ec_input_action_home').checked = 'checked';
    document.getElementById('ec_in_up_usr_txt_id').value = '';
    document.getElementById('ec_in_up_psd_txt_id').value = '';
    document.getElementById('ec_in_up_usr_list_id').value = '-1';
    document.getElementById('ec_in_up_code_id').value = '';
    document.getElementById('ec_in_up_aps_id').value = '-1';
    document.getElementById('ec_in_up_cats_id').value = '-1';
    document.getElementById('ec_in_up_imgs_id').value = '';
    document.getElementById('ec_sel_user_none').checked = '';
    document.getElementById('ec_input_action_home').checked = '';
  }
  else {
    document.getElementById('ec_in_up_code_id').value = ec_new_code_text;
    ec_avoid_infinite_loop = true;
    ec_mark_user(ec_selected_user);
  }
}

function ec_mark_user(ec_id) {
  ec_selected_user = ec_id;
  document.getElementById(ec_selected_user).checked = 'checked';
  switch (ec_selected_user) {
    case 'ec_sel_user_none': // None
      ec_selected_action =
       (ec_ap_ok && (ec_selected_action != 'ec_input_action_home')) ?
       'ec_input_action_add_p' : 'ec_input_action_home';
      document.getElementById('ec_in_up_usr_txt_id').value = '';
      document.getElementById('ec_in_up_psd_txt_id').value = '';
      document.getElementById('ec_in_up_usr_list_id').value = '-1';
    break;
    case 'ec_sel_user_new': // New user
      document.getElementById('ec_in_up_usr_txt_id').value =
       ec_new_user_text;
      document.getElementById('ec_in_up_psd_txt_id').value =
       ec_new_psd_text;
      document.getElementById('ec_in_up_usr_list_id').value = '-1';
    break;
    case 'ec_sel_user_old': // "Old" user
      document.getElementById('ec_in_up_usr_txt_id').value = '';
      document.getElementById('ec_in_up_psd_txt_id').value = '';
      document.getElementById('ec_in_up_usr_list_id').value =
       ec_selected_old_user;
    break;
  }
  ec_check_pwd_text();
  if (ec_avoid_infinite_loop) {
    ec_avoid_infinite_loop = false;
    ec_mark_action(ec_selected_action);
    ec_avoid_infinite_loop = true;
  }
}

function ec_mark_action(ec_id) {
  ec_selected_action = ec_id;
  if (ec_selected_action != '') {
    document.getElementById(ec_selected_action).checked = 'checked';
    switch (ec_selected_action) {
      case 'ec_input_action_add_p': // Additional Page
        document.getElementById('ec_in_up_aps_id').value = ec_selected_AP;
        document.getElementById('ec_in_up_cats_id').value = '-1';
        document.getElementById('ec_in_up_imgs_id').value = '';
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
      case 'ec_input_action_cat': // Category
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = ec_selected_cat;
        document.getElementById('ec_in_up_imgs_id').value = '';
        ec_selected_user = (ec_selected_user == 'ec_sel_user_none') ?
         'ec_sel_user_old' : ec_selected_user;
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
      case 'ec_input_action_img': // Image
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = ec_selected_cat;
        document.getElementById('ec_in_up_imgs_id').value = ec_selected_img;
        ec_selected_user = (ec_selected_user == 'ec_sel_user_none') ?
         'ec_sel_user_old' : ec_selected_user;
        ec_check_img_text();
      break;
      case 'ec_input_action_home': // Home
        document.getElementById('ec_in_up_aps_id').value = '-1';
        document.getElementById('ec_in_up_cats_id').value = '-1';
        document.getElementById('ec_in_up_imgs_id').value = '';
        document.getElementById('ec_in_up_imgs_warn').innerHTML = '';
      break;
    }
    if (ec_avoid_infinite_loop) {
      ec_avoid_infinite_loop = false;
      ec_mark_user(ec_selected_user);
      ec_avoid_infinite_loop = true;
    }
  }
}

function ec_rnd(ec_min, ec_max) {
  return Math.floor(ec_min + (ec_max - ec_min + 1) * Math.random() );
}

function ec_gen_txt(ec_length) {
  var t = '';
  var ec_reg_A = /[A-Z]+/;
  var ec_reg_a = /[a-z]+/;
  var ec_reg_0 = /[0-9]+/;
  var i = 0;
  var ec_l = 0;
  ec_l = parseInt(ec_length);
  if (ec_l < 3) {
    ec_err = '< 3';
    return '';
  }
  do {
    i++;
    switch (ec_rnd(0, 2)) {
      case 0: // A - Z
        t += String.fromCharCode(ec_rnd(65, 90));
      break;
      case 1: // a - z
        t += String.fromCharCode(ec_rnd(97, 122));
      break;
      case 2: // 0 - 9
        t += String.fromCharCode(ec_rnd(48, 57));
      break;
    }
    if (i > 500) {
      break;
    }
    if ((t.length) > (ec_l)) {
      t = t.substr(1, ec_l);
    }
  } while (
   (t.length < ec_l) ||
   !( ec_reg_A.test(t) && ec_reg_a.test(t) && ec_reg_0.test(t) )
  );
  if (i > 500) {
    ec_err = '> 500\n' + t;
    return '';
  }
  else {
    return t;
  }
}

function ec_gen_code() {
  var t = '';
  t = ec_gen_txt(ec_auto_code_digits_nb);
  if (t == '') {
    alert("Raté :\n" + ec_err);
    ec_new_code_text = 'Raté...';
  }
  else {
    ec_new_code_text = t;
  }
  ec_mark_line(-1);
}

function ec_gen_user() {
  var ec_reg_ap = /^\S+/;
  var ec_reg_cat = /\/\s(.+)$/;
  var ec_word = '';
  if (
   ec_selected_action == '' ||
   (ec_selected_action == 'ec_input_action_cat' && ec_selected_cat == '-1') ||
   (ec_selected_action == 'ec_input_action_img' &&
    (ec_selected_img == '' || ec_selected_cat == '-1')) ||
   (ec_selected_action == 'ec_input_action_add_p' && ec_selected_AP == '-1')
  ) {
    alert(ec_JS_message['ec_gen_user_act_miss']);
    return false;
  }
  else {
    var t = '';
    t = ec_gen_txt('8');
    if (t == '') {
      alert("Raté :\n" + ec_err);
      ec_new_psd_text = 'Raté...';
      return false;
    }
    else {
      ec_new_psd_text = t;
      ec_old_new_psd_text = ec_new_psd_text;
    }
    
   if (false) {
    ec_new_user_text = 'Nouvel utilisateur !';
   }
   else
   {
    
    switch (ec_selected_action) {
      case 'ec_input_action_add_p': // Additional Page
        ec_new_user_text = ec_reg_ap.exec(
document.ec_up_code.ec_in_up_aps.options[document.ec_up_code.ec_in_up_aps.selectedIndex].label
        );
      break;
      case 'ec_input_action_cat': // Category
      case 'ec_input_action_img': // Image
        ec_new_user_text = ec_reg_cat.exec(
document.ec_up_code.ec_in_up_cat.options[document.ec_up_code.ec_in_up_cat.selectedIndex].label
        )[1];
      if (ec_selected_action == 'ec_input_action_img') {
        ec_new_user_text +=  '_' + document.ec_up_code.ec_in_up_imgs_id.value;
      }
      break;
      case 'ec_input_action_home': // Home
      break;
    }
    
   }
    
    ec_mark_user('ec_sel_user_new');
    return true;
  }
}

function ec_gen_full_auto() {
  if (ec_gen_user()) ec_gen_code();
}

function ec_check_img_text() {
  document.getElementById('ec_in_up_imgs_warn').innerHTML =
   (ec_selected_img != '' && ec_selected_cat == '-1') ?
   ec_JS_message['ec_act_cat_miss'] : '';
}

function ec_check_pwd_text() {
  document.getElementById('ec_in_up_pwd_warn').innerHTML =
   (ec_new_psd_text == ec_old_new_psd_text &&
    ec_selected_user == 'ec_sel_user_new') ?
   ec_JS_message['ec_new_pwd_gen'] : '';
  // document.getElementById('ec_in_up_pwd_warn').innerHTML = ec_test_reg;
}

function ec_check_dis(ec_id) {
  ec_mark_line(ec_id);
  return confirm(ec_JS_message['ec_confirm_disable']);
}

function ec_check_del(ec_id) {
  ec_mark_line(ec_id);
  return confirm(ec_JS_message['ec_confirm_delete']);
}

function ec_check_tst(ec_id) {
  ec_mark_line(ec_id);
  return confirm(ec_JS_message['ec_confirm_test']);  
}

function ec_test() {
  alert('OK.');
}

function ec_init() {
  ec_mark_line(0);
}

